package io.objectbox.tree;

import io.objectbox.BoxStore;
import io.objectbox.Cursor;
import io.objectbox.annotation.apihint.Internal;
import io.objectbox.internal.CursorFactory;
import io.objectbox.relation.ToOne;

// THIS CODE IS GENERATED BY ObjectBox, DO NOT EDIT.

/**
 * ObjectBox generated Cursor implementation for "MetaLeaf".
 * Note that this is a low-level class: usually you should stick to the Box class.
 */
public final class MetaLeafCursor extends Cursor<MetaLeaf> {
    @Internal
    static final class Factory implements CursorFactory<MetaLeaf> {
        @Override
        public Cursor<MetaLeaf> createCursor(io.objectbox.Transaction tx, long cursorHandle, BoxStore boxStoreForEntities) {
            return new MetaLeafCursor(tx, cursorHandle, boxStoreForEntities);
        }
    }

    private static final MetaLeaf_.MetaLeafIdGetter ID_GETTER = MetaLeaf_.__ID_GETTER;


    private final static int __ID_name = MetaLeaf_.name.id;
    private final static int __ID_description = MetaLeaf_.description.id;
    private final static int __ID_flags = MetaLeaf_.flags.id;
    private final static int __ID_valueType = MetaLeaf_.valueType.id;
    private final static int __ID_valueEnum = MetaLeaf_.valueEnum.id;
    private final static int __ID_valueUnit = MetaLeaf_.valueUnit.id;
    private final static int __ID_valueMin = MetaLeaf_.valueMin.id;
    private final static int __ID_valueMax = MetaLeaf_.valueMax.id;
    private final static int __ID_branchId = MetaLeaf_.branchId.id;

    public MetaLeafCursor(io.objectbox.Transaction tx, long cursor, BoxStore boxStore) {
        super(tx, cursor, MetaLeaf_.__INSTANCE, boxStore);
    }

    @Override
    public final long getId(MetaLeaf entity) {
        return ID_GETTER.getId(entity);
    }

    /**
     * Puts an object into its box.
     *
     * @return The ID of the object within its box.
     */
    @Override
    public final long put(MetaLeaf entity) {
        ToOne<MetaBranch> branch = entity.branch;
        if(branch != null && branch.internalRequiresPutTarget()) {
            Cursor<MetaBranch> targetCursor = getRelationTargetCursor(MetaBranch.class);
            try {
                branch.internalPutTarget(targetCursor);
            } finally {
                targetCursor.close();
            }
        }
        String[] valueEnum = entity.getValueEnum();
        int __id5 = valueEnum != null ? __ID_valueEnum : 0;

        collectStringArray(cursor, 0, PUT_FLAG_FIRST,
                __id5, valueEnum);

        String name = entity.getName();
        int __id1 = name != null ? __ID_name : 0;
        String description = entity.getDescription();
        int __id2 = description != null ? __ID_description : 0;
        String valueUnit = entity.getValueUnit();
        int __id6 = valueUnit != null ? __ID_valueUnit : 0;
        String valueMin = entity.getValueMin();
        int __id7 = valueMin != null ? __ID_valueMin : 0;

        collect400000(cursor, 0, 0,
                __id1, name, __id2, description,
                __id6, valueUnit, __id7, valueMin);

        String valueMax = entity.getValueMax();
        int __id8 = valueMax != null ? __ID_valueMax : 0;

        long __assignedId = collect313311(cursor, entity.getId(), PUT_FLAG_COMPLETE,
                __id8, valueMax, 0, null,
                0, null, 0, null,
                __ID_branchId, entity.branch.getTargetId(), __ID_flags, entity.getFlags(),
                __ID_valueType, entity.getValueType(), 0, 0,
                0, 0, 0, 0,
                0, 0, 0, 0);

        entity.setId(__assignedId);

        attachEntity(entity);
        return __assignedId;
    }

    private void attachEntity(MetaLeaf entity) {
        // Transformer will create __boxStore field in entity and init it here:
        // entity.__boxStore = boxStoreForEntities;
    }

}
